(function($) {

var isIE = (function(){var undef, v = 3, div = document.createElement('div'), all = div.getElementsByTagName('i');while ( div.innerHTML = '<!--[if gt IE ' + (++v) + ']><i></i><![endif]-->', all[0]);return v > 4 ? v : undef;}());

function shuffle(array) {
	var i = array.length;
	while(i){
		var j = Math.floor(Math.random()*i);
		var t = array[--i];
		array[i] = array[j];
		array[j] = t;
	}
	return array;
};

function addEasing(){
	$.extend($.easing,{
		easeInExpo: function (x, t, b, c, d) {　return (t==0) ? b : c * Math.pow(2, 10 * (t/d - 1)) + b; },
		easeOutExpo: function (x, t, b, c, d) { return (t==d) ? b+c : c * (-Math.pow(2, -10 * t/d) + 1) + b; },
		easeInOutExpo: function (x, t, b, c, d) {
			if (t==0) return b; if (t==d) return b+c; if ((t/=d/2) < 1) return c/2 * Math.pow(2, 10 * (t - 1)) + b;
			return c/2 * (-Math.pow(2, -10 * --t) + 2) + b;
		},
		easeInBack: function (x, t, b, c, d, s) {
			if (s == undefined) s = 1.70158;
			return c*(t/=d)*t*((s+1)*t - s) + b;
		},
		easeOutBack: function (x, t, b, c, d, s) {
			if (s == undefined) s = 1.70158;
			return c*((t=t/d-1)*t*((s+1)*t + s) + 1) + b;
		},
		easeInOutBack: function (x, t, b, c, d, s) {
			if (s == undefined) s = 1.70158; 
			if ((t/=d/2) < 1) return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
			return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
		}
	});
};

function addImageOver(selector){
	$(selector).each(function(){
		var $obj = $(this);
		var url = $obj.attr('src');
			var preload = new Image();
			preload.src = url.replace('_out', '_over');
		$obj.attr('originsrc', url);
	}).on('mouseover', function(e){
		var $obj = $(this);
		$obj.attr('src', $obj.attr('originsrc').replace('_out', '_over'));
	}).on('mouseout',function(e){
		var $obj = $(this);
		$obj.attr('src', $obj.attr('originsrc'));
	})
};

function addMouseover(selector){
	$(selector).css('cursor','pointer').each(function (index, dom) {
		$(dom).bind('mouseover', function(){
			$(this).animate({opacity: '0.6'}, {duration: 300, easing: "linear"});
		}).bind('mouseout',function(){
			$(this).animate({opacity: '1'}, {duration: 100, easing: "linear"});
		});
	});
};

function log(text){
	//console.log('USER'+phase.user+' : '+ text);
}

function eventResize(){
	var stageMargin = Math.round( ( $(window).height()-656 ) /2 );
	if(stageMargin <= 0) stageMargin = 0;
	$('#settingLevel, #setting, #interface').css('margin-top', stageMargin+'px');
}

function message(htmlText, flagPlus){
	if(flagPlus){
		$message.html($message.html()+htmlText);
	} else {
		$message.html(htmlText);
	}
}

var minx = 400, miny = 400, maxx = 0, maxy = 0;

var flagDice = false;
var flagCover = false;
var timerDiceChange;
var timerDiceEnd;
var userDice = null;
var userDiceTemp = 0;

var $message, $dice, $diceBtn, $field, $infoUser, $cardCount, $cover;
var $q_btnarea, $q_honbun, $q_cardimage;
var userdata = [];
var phase;
var windowStatus = '';

var username = {'01':'アペ','02':'イメル','03':'オタ','04':'コンル','05':'スマ','06':'チクニ','07':'レラ','08':'ワッカ'};

var selectCount = 0;

var SettingReady = function() {
	this.usernumber = 4;
	this.user1 = 1;
	this.user2 = 2;
	this.user3 = 3;
	this.user4 = 4;
	this.mode = 'easy';
};

var sr = new SettingReady();

var UserData = function(charaElement, type) {
	this.$chara = charaElement.addClass('chara'+type);
	this.type = type;
	this.pos = 'start';
	this.cards = [];
	this.answerdQuestion = {};
	this.isGoal = false;
	this.goalnum = 0;
	this.bonus = 0;
	this.total = 0;
};

var PhaseData = function() {
	this.maxuser = 4;
	this.goaluser = [];
	this.goalnum = 4;
	this.turn = 0;
	this.name = 'wait';
	this.user = 0;
	this.viewuser = 0;
	this.que = [];
	this.queCount = 0;
	this.currentQuestion = "";
	this.flagHint = false;
	this.flagFail = false;
	this.flagGet = false;
	this.flagCount = 0;
	this.soloplay = false;
};

var audio = new Audio();

// サイコロを回して決定
function diceSelected(){
	if(flagDice){
		clearTimeout(timerDiceEnd);
		clearInterval(timerDiceChange);
		var num = Math.floor(Math.random()*6);
		userDice = num+1;
		$dice.css('background-position', '0 -' + num + '00px');
		message('"'+userDice+'"がでました。', false);
		log(userDice + 'がでました。');
		moveCalc(userDice, false);
		flagDice = false;
	}
}

// フェーズの変換
function phaseChange(status){
	// log(status + 'に phasechange します。');
	audio.pause();

	if(phase.maxuser-1 == phase.goaluser.length && !phase.soloplay){
		if(phase.user < phase.maxuser-1){
			phase.user++;
		} else {
			phase.user = 0;
		}
		if(userdata[phase.user].isGoal == false){
			phase.goaluser.push(phase.user);
			userdata[phase.user].isGoal = true;
			userdata[phase.user].goalnum = Number(phase.goalnum);
		}
		phaseChange('turnend');
		return true;
	} else if(phase.maxuser == phase.goaluser.length){
		createGoalLast();
		createSubWindow('small', 'type');
		return true;
	}

	switch(status){
		case 'whichmove':
			var tempPosition = position[userdata[phase.user].pos].next[0];
			$('<div class="marker" style="top:'+(position[tempPosition].centerY - 31)+'px;left:'+(position[tempPosition].centerX - 31)+'px;opacity:0;" position="'+tempPosition+'"></div>').appendTo($field).on('click', function(){
					moveCalc(phase.queCount, $(this).attr('position'));
					$('#field .marker').remove();
			}).animate({opacity: '1'}, {duration: 200, easing: "linear"}).animate({opacity: '0'}, {duration: 100, easing: "linear"}).animate({opacity: '1'}, {duration: 200, easing: "linear"});

			tempPosition = position[userdata[phase.user].pos].next[1];
			$('<div class="marker" style="top:'+(position[tempPosition].centerY - 31)+'px;left:'+(position[tempPosition].centerX - 31)+'px;opacity:0;" position="'+tempPosition+'"></div>').appendTo($field).on('click', function(){
					moveCalc(phase.queCount, $(this).attr('position'));
					$('#field .marker').remove();
			}).animate({opacity: '1'}, {duration: 200, easing: "linear"}).animate({opacity: '0'}, {duration: 100, easing: "linear"}).animate({opacity: '1'}, {duration: 200, easing: "linear"});

			message('どちらに移動しますか？', false);
			break;
		case 'finishmove':
			var god = position[userdata[phase.user].pos].god;
			var godHaveFlag = false;
			for (var i = 0; i < userdata[phase.user].cards.length; i++) {
				if(userdata[phase.user].cards[i] == god) godHaveFlag = true;
			};

			if( position[userdata[phase.user].pos].god !="" && position[userdata[phase.user].pos].god !="start" && !godHaveFlag){
				createQuestion( userdata[phase.user].pos );
				createSubWindow('small', 'type');
			} else if(position[userdata[phase.user].pos].c) {
				createJump();
				createSubWindow('small', 'type');
			} else if(position[userdata[phase.user].pos].god == "start") {
				createGoal();
				createSubWindow('small', 'type');
			} else {
				phaseChange('turnend');
			}
			
			break;
		case 'turnend':
			userdata[phase.user].$chara.css('z-index', '');

			if(phase.user < phase.maxuser-1){
				phase.user++;
			} else {
				phase.user = 0;
			}
			phase.viewuser = phase.user;

			if(userdata[phase.user].isGoal){
				phaseChange('turnend');
			} else {
				userdata[phase.user].$chara.css('z-index', 100);

				changeUserInfo(phase.viewuser);

				moveMap(userdata[phase.user].pos, true);

				if(sr.mode == 'medium'){
					var flagKatsura = false;
					for (var i = 0; i < userdata[phase.user].cards.length; i++) {
						if(userdata[phase.user].cards[i] == 'katsura') flagKatsura = true;
					};

					if(userdata[phase.user].pos == 'x22' && !flagKatsura){
						setTimeout(function(){
							createQuestion( userdata[phase.user].pos );
							createSubWindow('small', 'type');
						}, 2000);
					} else {
						$diceBtn.css('display','block');
						var text = (phase.user+1)+'P:'+ username[userdata[phase.user].type] + 'の番です。<br />サイコロを振ってください。';
						message(text, false);
					}
				} else {
					$diceBtn.css('display','block');
					var text = (phase.user+1)+'P:'+ username[userdata[phase.user].type] + 'の番です。<br />サイコロを振ってください。';
					message(text, false);
				}
			}
			break;
		case 'temp':
			break;
	}
}

function changeUserInfo(number){
	$('#userturn ul').css('background-image',  "url('./shared/images/btn_charatab_"+(Number(number)+1)+"_over.png')");
	$infoUser.attr('src','./data/images/chara/'+userdata[number].type+'_info.png');
	$cardCount.text('守り神カード：'+userdata[number].cards.length+'枚');
	$('#cardBtn').attr('user', number);
}

// サイコロの移動を計算
function moveCalc(count, which){
	phase.queCount = count;
	var isCrosspoint = false;
	var tempPosition = userdata[phase.user].pos;
	if(!which) which = 'no';
	for (var i = count - 1; i >= 0; i--) {
		if(position[tempPosition].next.length > 1){
			if( which == position[tempPosition].next[0] ){
				phase.que.push(position[tempPosition].next[0]);
				tempPosition = position[tempPosition].next[0];
			} else if( which == position[tempPosition].next[1] ){
				phase.que.push(position[tempPosition].next[1]);
				tempPosition = position[tempPosition].next[1];
			} else {
				isCrosspoint = true;
				break;
			}
		} else {
			phase.que.push(position[tempPosition].next[0]);
			tempPosition = position[tempPosition].next[0];
		}
		if(tempPosition == "start"){
			phase.goaluser.push(phase.user);
			userdata[phase.user].isGoal = true;
			userdata[phase.user].goalnum = Number(phase.goalnum);
			phase.goalnum--;
			phase.queCount=0;
			break;
		} else if(tempPosition == 'x22' && sr.mode=='medium'){
			phase.queCount=0;
			break;
		} else {
			phase.queCount--;
		}
	};
	if(phase.que.length >= 1){
		moveUser();
	} else {
		phaseChange('whichmove');
	}
}

// ジャンプカードで先に進む
function jumpCalcNext(){
	phase.queCount = 10;
	var count = 10;
	var isGod = false;
	var tempPosition = userdata[phase.user].pos;
	for (var i = count - 1; i >= 0; i--) {
		if(position[tempPosition].god != ''){
			isGod = true;
		} else {
			phase.que.push(position[tempPosition].next[0]);
			tempPosition = position[tempPosition].next[0];
		}
		if(tempPosition == "start"){
			phase.goaluser.push(phase.user);
			userdata[phase.user].isGoal = true;
			phase.queCount=0;
			break;
		} else {
			phase.queCount--;
		}
		if(isGod){
			phase.queCount=0;
			break;
		}
	};
	if(phase.que.length >= 1){
		moveUser();
	}
}

// ジャンプカードで前に戻る
function jumpCalcBack(){
	phase.queCount = 10;
	var count = 10;
	var isGod = false;
	var tempPosition = userdata[phase.user].pos;
	for (var i = count - 1; i >= 0; i--) {
		if(position[tempPosition].god != ''){
			isGod = true;
		} else {
			phase.que.push(position[tempPosition].prev[0]);
			tempPosition = position[tempPosition].prev[0];
		}
		if(tempPosition == "start"){
			phase.goaluser.push(phase.user);
			userdata[phase.user].isGoal = true;
			userdata[phase.user].goalnum = Number(phase.goalnum);
			phase.goalnum--;
			phase.queCount=0;
			break;
		} else {
			phase.queCount--;
		}
		if(isGod){
			phase.queCount=0;
			break;
		}
	};
	if(phase.que.length >= 1){
		moveUser();
	}
}

// ジャンプカードでどこにでも飛ぶ
function jumpAnywhere(){
	for (var i in position) {
		if(position[i].god != "" && position[i].god != "start"){
			if(String(i).match('x')){
				$('<div class="select x" style="left:'+(position[i].centerX-67)+'px;top:'+(position[i].centerY-67)+'px;opacity:0;" where="'+i+'"></div>').appendTo($field).on('click', jumpAnywhereClick).animate({opacity: '1'}, {duration: 200, easing: "linear"}).animate({opacity: '0'}, {duration: 100, easing: "linear"}).animate({opacity: '1'}, {duration: 200, easing: "linear"});;
			} else {
				$('<div class="select z" style="left:'+(position[i].centerX-95)+'px;top:'+(position[i].centerY-95)+'px;opacity:0;" where="'+i+'"></div>').appendTo($field).on('click', jumpAnywhereClick).animate({opacity: '1'}, {duration: 200, easing: "linear"}).animate({opacity: '0'}, {duration: 100, easing: "linear"}).animate({opacity: '1'}, {duration: 200, easing: "linear"});;
			}
			
		}
	}
}

// ジャンプカードでどこにでも飛ぶをクリックした時
function jumpAnywhereClick(){
	phase.que.push($(this).attr('where'));
	$field.find('.select').remove();
	moveUser();
}

// 移動時にコマが動く動作を指定
function moveUser(){
	var masu = phase.que[0];
	var posX = position[masu].centerX - 40;
	var posY = position[masu].centerY - 81;
	phase.que.shift();
	userdata[phase.user].$chara.animate({left:posX+'px', top:posY+'px'},
		{duration:500, ease:'easeOutExpo', complete:function(){
		log(masu + 'に移動。残り' + phase.que + 'です。');
		userdata[phase.user].pos = masu;
		if(phase.que.length > 0){
			moveUser();
		} else if(phase.queCount != 0) {
			phaseChange('whichmove');
		} else {
			phaseChange('finishmove');
		}
	}});
	moveMap(masu, false);
}

// マップの位置をセンターへ。
function moveMap(masu, isDelay){
	var posX = -(position[masu].centerX-40-400+60);
	var posY = -(position[masu].centerY-81-292);
	if(isDelay){
		$field.animate({left: posX+'px', top: posY+'px'}, {duration:1000, ease:'easeOutExpo',complete:function(){
			userdata[phase.user].$chara.animate({top: '-=20px'}, {duration:200, ease:'easeOutBack',queue:true}).animate({top: '+=20px'}, {duration:100, ease:'easeInExpo',queue:true}).animate({top: '-=10px'}, {duration:200, ease:'linear',queue:true}).animate({top: '+=10px'}, {duration:100, ease:'linear',queue:true});
		}});
	} else {
		$field.animate({left: posX+'px', top: posY+'px'}, {duration:300, ease:'linear'});
	}
}

// サブウィンドウの作成
function createSubWindow(size, type){
	if(windowStatus == 'question'){
		alert('試練中はこの画面を開けません');
	} else {
		if(size == 'small'){
			$('#subwin').addClass('small');
		} else {
			$('#subwin').removeClass('small');
		}
		$('#subwin').children().css('display','none');

		windowStatus = type;
		switch(type){
			case 'manual':
				$('#manual').css('display','block');
				$('#close').css('display','block');
				break;
			case 'ranking':
				createRanking();
				$('#ranking').css('display','block');
				$('#close').css('display','block');
				break;
			case 'card':
				$('#cards').html('');
				if(sr.mode == 'easy'){
					userdata[phase.viewuser].cards.sort();
				}
				for (var i = 0; i < userdata[phase.viewuser].cards.length; i++) {
					$('<img src="./data/images/card/'+userdata[phase.viewuser].cards[i]+'.jpg" />').appendTo('#cards');
				};
				$('#cards').css('display','block');
				$('#close').css('display','block');
				break;
			default:
				$('#question').css('display','block');
				windowStatus = 'question';
				break;
		};
		cover(true);
		$('#subwin').stop().css({display:'block', opacity: 0}).animate({opacity:1}, {duration:500, ease:'linear'});
	}
}

// サブウィンドウを閉じる
function closeSubWindow(){
	$('#subwin').stop().animate({opacity:0},
		{duration:500, ease:'linear', complete:function(){
		$('#subwin').css({display:'none'});
		cover(false);
		windowStatus = '';
	}});
}

// 後ろが動かないようにカバーのオンオフ
function cover(flag){
	if(flag){
		flagCover = true;
		$cover.css('display','block');
	} else {
		flagCover = false;
		$cover.css('display','none');
	}
}

// ゴールの生成
function createGoal(){
	$q_cardimage.attr('src', './data/images/shiren/start.jpg');
	$q_honbun.html(
		'<img src="./data/images/chara/'+userdata[phase.user].type+'_goal.png" /><br /><span class="center">（'+username[userdata[phase.user].type]+'は村に戻った！）</span>');

	$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', function(){
		$q_btnarea.find('.btn').remove();
		$q_btnarea.removeClass('twobtn');
		closeSubWindow();
		setTimeout(function(){
			phaseChange("turnend");
		}, 1000);
	});
	$q_btnarea.addClass('twobtn');
	$('#question .title img').attr('src', './shared/images/title_goal.png');
}

function createGoalLast(){
	$q_cardimage.attr('src', './data/images/shiren/start.jpg');
	$q_honbun.html(
		'<img src="./data/images/chara/'+userdata[phase.user].type+'_goal.png" /><br /><span class="center">（'+username[userdata[phase.user].type]+'は村に戻った！）</span>');

	$('<a class="btn long">順位発表を見る</a>').appendTo($q_btnarea).on('click', function(){
		message('ゲームが終了しました。', false);
		$q_btnarea.find('.btn').remove();
		$q_btnarea.removeClass('twobtn');
		closeSubWindow();
		setTimeout(function(){
			createSubWindow('big', 'ranking');
		}, 1000);
	});
	$q_btnarea.addClass('twobtn');
	$('#question .title img').attr('src', './shared/images/title_goal.png');
}

// ジャンプカードの生成
function createJump(){
	var m=0, x=0, y=0;
	var jumpcards=[], hit=[];
	var fixNumber = 0;

	hit[0] = 0;  jumpcards[0] = ''; 
	hit[1] = 50; jumpcards[1] = 'シネ<span>プ</span>　エトコ　タ　アン　カムイ　オッタ　ホプニ';
	hit[2] = 30; jumpcards[2] = 'シネ<span>プ</span>　オカケ　タ　アン　カムイ　オッタ　ホシピ';
	hit[3] = 15; jumpcards[3] = 'エエラマス　カムイ　オッタ　ホプニ';
	hit[4] = 5;  jumpcards[4] = 'セタ　オ<span>ロ</span>　パ<span>ク</span>ノ　ホシピ';

	for(i=0; i<=hit.length-1; i++) {
		m += hit[i];
	}
	n = Math.floor(Math.random() * m);
	n++;
	for(i=0; i<=hit.length - 1; i++) {
		x = y;
		y += hit[i];
		if(x<n && n<=y) fixNumber = i;
	}

	$q_cardimage.attr('src', './data/images/jumpcard/'+fixNumber+'_ainu.jpg');
	$q_honbun.html(jumpcards[fixNumber]);

	$('<a class="btn" answer="0">日本語をみる</a>').appendTo($q_btnarea).on('click', function(){
		if( $(this).text() == '日本語をみる' ){
			$q_cardimage.attr('src', $q_cardimage.attr('src').replace('_ainu', '_ja'));
			$(this).text('アイヌ語をみる')
		} else {
			$q_cardimage.attr('src', $q_cardimage.attr('src').replace('_ja', '_ainu'));
			$(this).text('日本語をみる')
		}
	});
	$('<a class="btn" answer="'+fixNumber+'">OK</a>').appendTo($q_btnarea).on('click', function(){
			switch(Number($(this).attr('answer'))){
				case 1:
					jumpCalcNext(); // 次の神様へ。
					break;
				case 2:
					jumpCalcBack(); // 前の神様へ
					break;
				case 3:
					jumpAnywhere(); // 好きな神様へ
					break;
				case 4:
					phase.que.push('x14'); // 犬の神様へ
					moveUser();
					windowStatus = '';
					break;
			}
			$q_btnarea.find('.btn').remove();
			$q_btnarea.removeClass('twobtn');
			closeSubWindow();
	});
	$q_btnarea.addClass('twobtn');
	$('#question .title img').attr('src', './shared/images/title_jump.png');
}

// 試練の生成
function createQuestion(pos){
	log(position[pos].god + 'の試練');

	if(sr.mode == 'easy'){
		createQuestionEasy(pos);
		return;
	}

	var q = question[String(position[pos].god)];
	phase.currentQuestion = String(position[pos].god);
	phase.flagHint = false;
	phase.flagFail = false;
	phase.flagGet = false;
	phase.flagCount = 0;

	$q_cardimage.attr('src', './data/images/shiren/'+String(position[pos].god)+'.jpg');
	$('#question .title img').attr('src', './shared/images/title_shiren.png');

	if(q.info[0] == "番号選択"){
		$q_honbun.html(q.info[3]);
		for (var i = 4; i <= 7; i++) {
			if(q.info[i] != ""){
				$('<a class="btn" answer="'+(i-3)+'">'+(i-3)+':'+q.info[i]+'</a>').appendTo($q_btnarea).on('click', questionAnswer);
			};
		};
	
	} else if(q.info[0] == "口頭"){
		$q_honbun.html(q.info[3] + '<br /><span class="issyo">一緒にプレイしている人に正解を判定してもらおう！</span>');

		if(phase.currentQuestion == 'sakana'){
			$q_btnarea.addClass('longtext');
		}

		$('<a class="btn" answer="0">正解を言えた</a>').appendTo($q_btnarea).on('click', koutouAnswer);
		$('<a class="btn" answer="1">不正解だった</a>').appendTo($q_btnarea).on('click', koutouAnswer);
		$('<a class="btn arrow">ヒントを見る</a>').appendTo($q_btnarea).on('click', koutouOpenHint);
		$('<a class="btn arrow">正解を見る</a>').appendTo($q_btnarea).on('click', koutouOpenAnswer);

	} else if(q.info[0] == "サイコロを振る"){
		$q_honbun.html(q.info[3]);
		$q_btnarea.addClass('twobtn');

		if(q.info[1] == "オキナ"){
			$('<a class="btn long" answer="0">サイコロの出目を確認する</a>').appendTo($q_btnarea).on('click', function(){
				$q_honbun.html("「たこの神様、私を助けてください」といってサイコロをふる。<br /><img src='./data/images/dice/kaigyo.png' width='320' height='162' style='margin-top:10px;'>");
				$q_btnarea.html('');
				$q_btnarea.css('top', '430px');
				$('<a class="btn long" answer="0">サイコロを振る</a>').appendTo($q_btnarea).on('click', function(){
					$q_btnarea.find('.btn').remove();
					timerDiceChange = setInterval( function(){
						var num = Math.floor(Math.random()*6);
						$dice.css('background-position', '0 -' + num + '00px');
					}, 125);
					timerDiceEnd = setTimeout( createRollDice, 2000);
				});
			});
		} else {
			$('<a class="btn long" answer="0">サイコロを振る</a>').appendTo($q_btnarea).on('click', function(){
				$q_btnarea.find('.btn').remove();
				timerDiceChange = setInterval( function(){
					var num = Math.floor(Math.random()*6);
					$dice.css('background-position', '0 -' + num + '00px');
				}, 125);
				timerDiceEnd = setTimeout( createRollDice, 2000);
			});
		}
	} else if(q.info[0] == "複数回答"){
		$('#question').addClass('multiple');

		$q_btnarea.addClass('threebtn');

		selectCount = 0;
		phase.flagCount = Number(q.info[14]);

		$q_honbun.html(q.info[3] + '<br /><span class="issyo">言った数＋サイコロの目が'+phase.flagCount+'以上だったら、守り神カードを貰える！</span>');
		$('<div class="selectBox"><p><img src="./shared/images/select_text_0.png" /></p><ul class="updown"><li class="up"></li><li class="down"></li></ul></div>').appendTo($q_btnarea);

		$('<a class="btn long" answer="0">サイコロを振る</a>').appendTo($q_btnarea).on('click', function(){
			if(phase.flagHint){
				phase.flagCount = q.info[15];
			}
			$q_honbun.html(q.info[3] + '<br /><span class="issyo">言った数＋サイコロの目が'+phase.flagCount+'以上だったら、守り神カードを貰える！</span>');
			$q_btnarea.removeClass('threebtn');
			$q_btnarea.html('');
			timerDiceChange = setInterval( function(){
				var num = Math.floor(Math.random()*6);
				$dice.css('background-position', '0 -' + num + '00px');
			}, 125);
			timerDiceEnd = setTimeout( createMultipleAnswer, 2000);
		});

		$('<a class="btn arrow">ヒントを見る</a>').appendTo($q_btnarea).on('click', multipleOpenHint);
		$('<a class="btn arrow">正解を見る</a>').appendTo($q_btnarea).on('click', koutouOpenAnswer);
	}
}

// Easy
function createQuestionEasy(pos){
	log(position[pos].god + ' Easy');

	var q = question[String(position[pos].god)];
	phase.currentQuestion = String(position[pos].god);
	phase.flagHint = false;
	phase.flagFail = false;
	phase.flagGet = false;
	phase.flagCount = 0;

	var qPos;

	if(userdata[phase.user].answerdQuestion[position[pos].god] == undefined){
		qPos = userdata[phase.user].answerdQuestion[position[pos].god] = {};
		qPos.answerd = [];

		var questionOrderArray = [0,1,2];
		shuffle(questionOrderArray);
		qPos.questionOrder = questionOrderArray;

		var answerOrderArray = [0,1,2];
		shuffle(answerOrderArray);
		qPos.answerOrder = answerOrderArray;
	} else {
		qPos = userdata[phase.user].answerdQuestion[position[pos].god];
	}

	if(qPos.answerd.length==3){
		$q_honbun.html('あなたはすでにこの神様からの質問に3回正解しています。');
		message('あなたはすでにこの神様からの試練に3回正解しています。', false);
		$q_cardimage.attr('src', './data/images/card/'+cardlevel[qPos.answerd.length]+phase.currentQuestion+'.jpg');

		$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
		$q_btnarea.css({'position':'absolute'}).addClass('twobtn');
	} else {
		$q_cardimage.attr('src', './data/images/shiren/'+String(position[pos].god)+'.jpg');
		$('#question .title img').attr('src', './shared/images/title_shiren.png');
		$q_btnarea.css({'position':'absolute'}).addClass('easybtn');

		$q_honbun.html(q.easy[qPos.questionOrder[qPos.answerd.length]].question);
		for (var i = 0; i < 3; i++) {
			if(q.easy[qPos.questionOrder[qPos.answerd.length]].answers[qPos.answerOrder[i]] != ""){
				$('<a class="btn long" answer="'+q.easy[qPos.questionOrder[qPos.answerd.length]].answers[qPos.answerOrder[i]].id+'">'+(i+1)+': '+q.easy[qPos.questionOrder[qPos.answerd.length]].answers[qPos.answerOrder[i]].ainu+'</a>').appendTo($q_btnarea).on('click', questionAnswerEasy);
			};
		};
	}
}

// 番号選択での答え
function questionAnswerEasy(){
	var q = question[phase.currentQuestion];
	var qPos = userdata[phase.user].answerdQuestion[phase.currentQuestion];

	if($(this).attr('answer') == q.easy[qPos.questionOrder[qPos.answerd.length]].collect){
		answerCorrectEasy();
	} else {
		if(phase.flagHint){
			answerWrongEasy();
		} else {
			phase.flagHint = true;
			$q_honbun.html('ヒントはこちら！<br />'+q.easy[qPos.questionOrder[qPos.answerd.length]].hint);
		}
	}
}

function answerCorrectEasy(){
	var q = question[phase.currentQuestion];
	var qPos = userdata[phase.user].answerdQuestion[phase.currentQuestion];
	$q_honbun.html('<img src="./shared/images/image_correct.png" /><br /><span class="center">正解！</span>');
	$q_btnarea.find('.btn').remove();
	$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('easybtn');
	
	$('<a class="btn long">解答を確認する</a>').appendTo($q_btnarea).on('click', function(){
		var answerHTML = '';
		for (var i = 0; i < 3; i++) {
			if(q.easy[0].answers[i] != ""){
				answerHTML += '　' + (i+1)+': '+q.easy[qPos.questionOrder[qPos.answerd.length]].answers[qPos.answerOrder[i]].ja+'<br />';
			};
		}
		qPos.answerd.push(qPos.questionOrder[qPos.answerd.length]);
		userdata[phase.user].cards.push(cardlevel[qPos.answerd.length]+phase.currentQuestion);

		$q_honbun.html('選択肢の答えは、<br /><br />'+answerHTML+'<br />でした。'+qPos.answerd.length+'回目の守り神カードをゲット！');
		$q_btnarea.find('.btn').remove();
		message('正解!!<br />'+qPos.answerd.length+'回目の守り神カードをゲット！', false);
		$q_cardimage.attr('src', './data/images/card/'+cardlevel[qPos.answerd.length]+phase.currentQuestion+'.jpg');

		$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
		$q_btnarea.css('position','absolute').addClass('twobtn');
	});
}

function answerWrongEasy(){
	var q = question[phase.currentQuestion];
	var qPos = userdata[phase.user].answerdQuestion[phase.currentQuestion];
	phase.flagFail = true;
	$q_cardimage.attr('src', './data/images/shiren/'+phase.currentQuestion+'.jpg');
	$q_honbun.html('<img src="./shared/images/image_wrong.png" /><br /><span class="center">'+q.info[1]+'の試練を<br />クリアできなかった!</span>');
	$q_btnarea.find('.btn').remove();
	$('<a class="btn long">正解を見る</a>').appendTo($q_btnarea).on('click', function(){
		var answerHTML = '';
		for (var i = 0; i < 3; i++) {
			if(q.easy[0].answers[i] != ""){
				answerHTML += '　' + (i+1)+': '+q.easy[qPos.questionOrder[qPos.answerd.length]].answers[qPos.answerOrder[i]].ja+'<br />';
			};
		}
		$q_honbun.html('選択肢の答えは、<br /><br />'+answerHTML+'<br />でした。守り神カードをゲットできませんでした。');
		$q_btnarea.find('.btn').remove();
		$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
		$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('easybtn');
	});
	$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('longtext').removeClass('easybtn');
}


function createRollDice(){
	clearTimeout(timerDiceEnd);
	clearInterval(timerDiceChange);
	var num = Math.floor(Math.random()*6);
	userDice = num+1;
	$dice.css('background-position', '0 -' + num + '00px');
	message('"'+userDice+'"がでました。', false);

	var q = question[phase.currentQuestion];

	$q_btnarea.addClass('twobtn');

	if(phase.currentQuestion == 'kaigyo'){
		var flagAccoroKamui = false;
		for (var i = 0; i < userdata[phase.user].cards.length; i++) {
			if(userdata[phase.user].cards[i] == 'tako') flagAccoroKamui = true;
		};

		if(flagAccoroKamui){
			switch(userDice){
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
					$('<a class="btn long" answer="0">出た目の数、先に進む。</a>').appendTo($q_btnarea).on('click', function(){
							closeSubWindow();
							$q_btnarea.css('top', '');
							$q_btnarea.find('.btn').remove();
							$q_btnarea.css('position','absolute').removeClass('twobtn').removeClass('longtext');
							setTimeout(function(){
								moveCalc(userDice, false);
							}, 1000);
					});
					break;
				case 6:
					$('<a class="btn long" answer="0">トマリコ<span>ロ</span>カムイのところまで戻る。</a>').appendTo($q_btnarea).on('click', function(){
							$q_btnarea.css('top', '');
							rollDiceToMove('x18');
					});
					break;
			}
		} else {
			switch(userDice){
				case 1:
				case 2:
				case 3:
					$('<a class="btn long" answer="0">出た目の数、先に進む。</a>').appendTo($q_btnarea).on('click', function(){
							closeSubWindow();
							$q_btnarea.css('top', '');
							$q_btnarea.find('.btn').remove();
							$q_btnarea.css('position','absolute').removeClass('twobtn').removeClass('longtext');
							setTimeout(function(){
								moveCalc(userDice, false);
							}, 1000);
					});
					break;
				case 4:
				case 5:
				case 6:
					$('<a class="btn long" answer="0">トマリコ<span>ロ</span>カムイのところまで戻る。</a>').appendTo($q_btnarea).on('click', function(){
						$q_btnarea.css('top', '');
							rollDiceToMove('x18');
					});
					break;
			}
		}

	} else if(phase.currentQuestion == 'kappa'){
		switch(userDice){
			case 1:
				$('<a class="btn long" answer="0">コタンに飛ばされてゲーム終了。</a>').appendTo($q_btnarea).on('click', function(){
						phase.goaluser.push(phase.user);
						userdata[phase.user].isGoal = true;
						userdata[phase.user].goalnum = Number(phase.goalnum);
						phase.goalnum--;
						rollDiceToMove('start');
				});
				break;
			case 2:
			case 3:
				$('<a class="btn long" answer="0">トマリコ<span>ロ</span>カムイのところに飛ぶ。</a>').appendTo($q_btnarea).on('click', function(){
						rollDiceToMove('x18');
				});
				break;
			case 4:
			case 5:
				$('<a class="btn long" answer="0">ワッカウ<span>シ</span>カムイのところに戻される。</a>').appendTo($q_btnarea).on('click', function(){
						rollDiceToMove('z7');
				});
				break;
			case 6:
				$('<a class="btn long" answer="0">ミントゥチのセ<span>レ</span>マ<span>ク</span>カンピがもらえる。</a>').appendTo($q_btnarea).on('click', getMamorigami);
				break;
		}
	}
}

function rollDiceToMove(pos){
	closeSubWindow();
	$q_btnarea.find('.btn').remove();
	$q_btnarea.css('position','absolute').removeClass('threebtn').removeClass('twobtn').removeClass('longtext');
	phase.que.push(pos);
	setTimeout(moveUser, 1000);
}


function createMultipleAnswer(){
	clearTimeout(timerDiceEnd);
	clearInterval(timerDiceChange);
	var q = question[phase.currentQuestion];
	var num = Math.floor(Math.random()*6);
	userDice = num+1;
	$dice.css('background-position', '0 -' + num + '00px');
	message('"'+userDice+'"がでました。', false);

	if(phase.flagHint){
		phase.flagCount = q.info[15];
	}

	var checkNum = userDice + selectCount;

	if(phase.currentQuestion == 'yuri'){
		$q_btnarea.addClass('longtext');
	}
	$q_btnarea.removeClass('threebtn');
	$q_btnarea.addClass('twobtn');

	if(phase.flagFail){
		phase.flagGet = false;
		// ゲットできなかった
		$q_honbun.html('<img src="./shared/images/image_wrong.png" /><br /><span class="issyo">正解を見て解答したので、守り神カードはもらえなかった。</span>');
		$('<a class="btn long">正解を見る</a>').appendTo($q_btnarea).on('click', multipleShowAnswer);
	} else {
		if(checkNum>= Number(phase.flagCount)){
			phase.flagGet = true;
			// ゲットできたら
			$q_honbun.html('<img src="./shared/images/image_correct.png" /><br /><span class="issyo">言った数('+selectCount+')＋サイコロの目('+userDice+')の合計が'+phase.flagCount+'以上だったので、守り神カードを貰える！</span>');
		} else {
			phase.flagGet = false;
			// ゲットできなかった
			$q_honbun.html('<img src="./shared/images/image_wrong.png" /><br /><span class="issyo">言った数('+selectCount+')＋サイコロの目('+userDice+')の合計が'+phase.flagCount+'以下だったので、守り神カードはもらえなかった。</span>');
		}

		$('<a class="btn long">正解を見る</a>').appendTo($q_btnarea).on('click', multipleShowAnswer);
	}
}

// 守り神カードゲットのチャンス
function createCardGetChanse(){
	var q = question[phase.currentQuestion];

	$q_cardimage.attr('src', './data/images/card/'+phase.currentQuestion+'.jpg');

	if(phase.flagHint && !phase.flagFail){
		// ヒントだけ
		$q_honbun.html('サイコロの出目で守り神カードゲットのチャンス<br />'+q.info[11]);
	} else if(phase.flagFail) {
		// 正解を見た
		$q_honbun.html('サイコロの出目で守り神カードゲットのチャンス<br />'+q.info[13]);
	} else {
		// そのまま
		$q_honbun.html('サイコロの出目で守り神カードゲットのチャンス<br />'+q.info[9]);
	}
	$q_btnarea.find('.btn').remove();
	$q_btnarea.css('position','absolute');

	timerDiceChange = setInterval( function(){
		var num = Math.floor(Math.random()*6);
		$dice.css('background-position', '0 -' + num + '00px');
	}, 125);
	timerDiceEnd = setTimeout( diceMamorigami, 2000);
}

// 試練のサブウィンドウを閉じる
function closeWrongQuestion(){
	closeSubWindow();
	$q_btnarea.find('.btn').remove();
	$q_btnarea.css('position','absolute').removeClass('threebtn').removeClass('twobtn').removeClass('longtext');
	$('#question').removeClass('multiple');
	phaseChange('turnend');
}

// 番号選択での答え
function questionAnswer(){
	var q = question[phase.currentQuestion];
	if(Number($(this).attr('answer')) == q.info[8]){
		answerCorrect();
	} else {
		if(phase.flagHint){
			answerWrong();
		} else {
			phase.flagHint = true;
			$q_honbun.html('ヒントはこちら！<br />'+q.info[10]);
		}
	}
}

// 口頭での答え
function koutouAnswer(){
	var q = question[phase.currentQuestion];
	if(Number($(this).attr('answer')) == 0){
		answerCorrect();
	} else {
		if(phase.flagHint){
			answerWrong();
		} else {
			phase.flagHint = true;
			$('#question .btnarea .btn:contains("ヒントを見る")').text('問題に戻る');
			$q_honbun.html('ヒントはこちら<br />'+q.info[10]);
		}
	}
}

function answerCorrect(){
	var q = question[phase.currentQuestion];
	$q_honbun.html('<img src="./shared/images/image_correct.png" /><br /><span class="center">正解！</span>');
	$q_btnarea.find('.btn').remove();
	$q_btnarea.css('position','absolute').addClass('twobtn');
	
	$('<a class="btn long">解答を確認する</a>').appendTo($q_btnarea).on('click', function(){
		$q_honbun.html('正解は、<br />'+q.info[12]+'<br /><br /><span class="center">サイコロを振って'+q.info[1]+'の守り神カードを<br />ゲットするチャンス!!</span>');
		$q_btnarea.find('.btn').remove();
		if(phase.currentQuestion == 'sakana'){
			$q_btnarea.addClass('twobtn').removeClass('longtext');
		}
		message('正解!!<br />サイコロを振って守り神カードをゲットしよう！', false);
		$q_cardimage.attr('src', './data/images/card/'+phase.currentQuestion+'.jpg');
		$('<a class="btn long">サイコロを振る</a>').appendTo($q_btnarea).on('click', createCardGetChanse);
		$('<a class="btn long">正解を音声で聞く</a>').appendTo($q_btnarea).on('click', playAudio);
		$q_btnarea.css('position','absolute').addClass('twobtn');
	});
}

//
function playAudio(){
	var q = question[phase.currentQuestion];
	if(audio.src != 'data/audio/'+phase.currentQuestion+'.mp3'){
		audio.src = 'data/audio/'+phase.currentQuestion+'.mp3';
		audio.load();
	} else {
		audio.pause();
		audio.currentTime = 0;
	}
	audio.play();
}

function answerWrong(){
	var q = question[phase.currentQuestion];
	phase.flagFail = true;
	$q_cardimage.attr('src', './data/images/shiren/'+phase.currentQuestion+'.jpg');
	$q_honbun.html('<img src="./shared/images/image_wrong.png" /><br /><span class="center">'+q.info[1]+'の試練を<br />クリアできなかった!</span>');
	$q_btnarea.find('.btn').remove();
	$('<a class="btn long">正解を見る</a>').appendTo($q_btnarea).on('click', function(){
		$q_honbun.html('正解は、<br />'+q.info[12]);
		$q_btnarea.find('.btn').remove();
		$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
		$('<a class="btn long">正解を音声で聞く</a>').appendTo($q_btnarea).on('click', playAudio);
		$q_btnarea.css('position','absolute').addClass('twobtn');
	});
	$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('longtext');
}

function multipleAnswerWrong(){
	var q = question[phase.currentQuestion];
	phase.flagFail = true;
	$q_cardimage.attr('src', './data/images/shiren/'+phase.currentQuestion+'.jpg');
	$q_honbun.html('<img src="./shared/images/image_wrong.png" /><br /><span class="center">'+q.info[1]+'の試練を<br />クリアできなかった!</span>');
	$q_btnarea.find('.btn').remove();
	$('<a class="btn long">正解を見る</a>').appendTo($q_btnarea).on('click', function(){
		$q_honbun.html('正解は、<br />'+q.info[12]);
		$q_btnarea.find('.btn').remove();
		$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
		$('<a class="btn long">正解を音声で聞く</a>').appendTo($q_btnarea).on('click', playAudio);
		$q_btnarea.css('position','absolute').addClass('twobtn');
	});
	$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('longtext');
}


function koutouOpenHint(){
	var q = question[phase.currentQuestion];
	phase.flagHint = true;

	$(this).next().text('正解を見る');
	if($(this).text() == 'ヒントを見る'){
		$q_honbun.html(q.info[10]);
		$(this).text('問題に戻る');
	} else {
		$q_honbun.html(q.info[3] + '<br /><span class="issyo">一緒にプレイしている人に正解を判定してもらおう！</span>');
		$(this).text('ヒントを見る');
	}
}

function koutouOpenAnswer(){
	var q = question[phase.currentQuestion];
	if($(this).text() == '正解を見る'){
		if(window.confirm('正解を見て解答すると、守り神カードがゲットできませんがよろしいですか？')){
			phase.flagHint = true;
			phase.flagFail = true;
			$(this).prev().text('ヒントを見る');
			$q_honbun.html('正解は、<br />'+q.info[12]);
			$q_btnarea.html('');
			//$(this).text('問題に戻る');
			$('<a class="btn long" answer="0">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
			$('<a class="btn long">正解を音声で聞く</a>').appendTo($q_btnarea).on('click', playAudio);
			$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('threebtn');
		}
	} else {
		$q_honbun.html(q.info[3] + '<br /><span class="issyo">一緒にプレイしている人に正解を判定してもらおう！</span>');
		$(this).text('正解を見る');
	}
}

function multipleShowAnswer(){
	var q = question[phase.currentQuestion];
	$q_honbun.html('正解は、<br />'+q.info[12]);
	$q_btnarea.html('');
	// if(phase.flagGet){
	// 	$('<a class="btn long" answer="0">守り神カードを貰う</a>').appendTo($q_btnarea).on('click', function(){
	// 		$q_cardimage.attr('src', './data/images/card/'+phase.currentQuestion+'.jpg');
	// 		getMamorigami();
	// 	});
	// } else {
	// 	$('<a class="btn long" answer="0">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
	// }
	$('<a class="btn long" answer="0">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
	$('<a class="btn long">正解を音声で聞く</a>').appendTo($q_btnarea).on('click', playAudio);
	$q_btnarea.css('position','absolute').addClass('twobtn').removeClass('threebtn');
}


function multipleOpenHint(){
	var q = question[phase.currentQuestion];

	if($(this).text() == 'ヒントを見る'){
		if(phase.currentQuestion == 'kumo'){
			phase.flagHint = true;
			$q_honbun.html(q.info[10]);
			$(this).text('問題に戻る');
		} else {
			if(window.confirm('クリアに必要な言った数とサイコロの目の合計が'+q.info[15]+'個になりますがよろしいですか？')){
				phase.flagHint = true;
				$q_honbun.html(q.info[10]);
				$(this).text('問題に戻る');
			}
		}
	} else {
		$q_honbun.html(q.info[3] + '<br /><span class="issyo">言った数＋サイコロの目が'+q.info[15]+'以上だったら、守り神カードを貰える！</span>');
		$(this).text('ヒントを見る');
	}
}

// 守り神を引くときのサイコロ
function diceMamorigami(){
	clearTimeout(timerDiceEnd);
	clearInterval(timerDiceChange);
	var num = Math.floor(Math.random()*6);
	userDice = num+1;
	$dice.css('background-position', '0 -' + num + '00px');
	message('"'+userDice+'"がでました。', false);

	checkMamorigami(userDice);
}

// 守り神ゲットの判断
function checkMamorigami(num){
	var q = question[phase.currentQuestion];
	var flagCorrect = false;

	if(phase.flagHint && !phase.flagFail){
		// ヒントだけ
		for (var i = 0; i < q.info[15].length; i++) {
			if(q.info[15][i] == num) flagCorrect = true;
		};
	} else if(phase.flagFail) {
		// 正解を見た
		for (var i = 0; i < q.info[16].length; i++) {
			if(q.info[16][i] == num) flagCorrect = true;
		};
	} else {
		// そのまま
		for (var i = 0; i < q.info[14].length; i++) {
			if(q.info[14][i] == num) flagCorrect = true;
		};
	}

	if(flagCorrect){
		getMamorigami();
	} else {
		ungetMamorigami();
	}
}

function getMamorigami(){
	var q = question[phase.currentQuestion];
	userdata[phase.user].cards.push(phase.currentQuestion);
	if(userdata[phase.user].pos == 'x22'){
		$q_honbun.html('<img src="./shared/images/image_get.png" /><br /><span class="center">ランコの神から舟を作った。<br />これで川を下れる！</span>');
	} else {
		$q_honbun.html('<img src="./shared/images/image_get.png" /><br /><span class="center">'+q.info[1]+'の守り神カードを<br />ゲットした！</span>');
	}
	$q_btnarea.find('.btn').remove();
	$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
	//$q_btnarea.css('position','static');
}

function ungetMamorigami(){
	var q = question[phase.currentQuestion];
	$q_cardimage.attr('src', './data/images/card/'+phase.currentQuestion+'.jpg');
	$q_honbun.html('<img src="./shared/images/image_wrong.png" /><br /><span class="center">'+q.info[1]+'の守り神カードを<br />ゲットできなかった!</span>');
	$q_btnarea.find('.btn').remove();
	$('<a class="btn long">次の人のターンへ</a>').appendTo($q_btnarea).on('click', closeWrongQuestion);
	//$q_btnarea.css('position','static');
}

// ランキング生成
function createRanking(){
	var $ranking = $('#ranking');
	switch(phase.maxuser){
		case 1:
			$ranking.find('.rank:gt(0)').addClass('none');
			break;
		case 2:
			$ranking.find('.rank:gt(1)').addClass('none');
			break;
		case 3:
			$ranking.find('.rank:gt(2)').addClass('none');
			break;
	}
	var $userdom = '';

	var totalArray = [];

	for (var i = 0; i < phase.maxuser; i++) {
		var goalbonus = 0;
		if(userdata[i].isGoal && phase.maxuser==1){
			switch(Number(userdata[i].goalnum)){
				case 1:
					goalbonus = 0;
					break;
			}
		}
		if(userdata[i].isGoal && phase.maxuser==2){
			switch(Number(userdata[i].goalnum)){
				case 1:
					goalbonus = 0;
					break;
				case 2:
					goalbonus = 3;
					break;
			}
		} else if(userdata[i].isGoal && phase.maxuser==3){
			switch(Number(userdata[i].goalnum)){
				case 1:
					goalbonus = -3;
					break;
				case 2:
					goalbonus = 0;
					break;
				case 3:
					goalbonus = 3;
					break;
			}
		} else if(userdata[i].isGoal && phase.maxuser==4){
			switch(Number(userdata[i].goalnum)){
				case 1:
					goalbonus = -3;
					break;
				case 2:
					goalbonus = -1;
					break;
				case 3:
					goalbonus = 1;
					break;
				case 4:
					goalbonus = 3;
					break;
			}
		};
		userdata[i].bonus = goalbonus;
		userdata[i].total = (userdata[i].cards.length) + goalbonus;
		totalArray.push({'num':i, 'total':userdata[i].total});
	};

	totalArray.sort(function(a, b){
		var x = a.total;
		var y = b.total;
		if (x > y) return -1;
		if (x < y) return 1;
		return 0;
	});

	for (var i = 0; i < totalArray.length; i++) {
		$userdom = $ranking.find('.rank').eq(i);
		$userdom.find('.image img').attr('src','data/images/chara/'+userdata[totalArray[i]['num']].type+'_field.png');
		$userdom.find('.name').text((i+1)+'P:'+ username[userdata[totalArray[i]['num']].type]);
		$userdom.find('.cards').text('+'+(userdata[totalArray[i]['num']].cards.length));

		if(userdata[totalArray[i]['num']].bonus > 0){
			$userdom.find('.bonus').text('+'+userdata[totalArray[i]['num']].bonus);
		} else {
			$userdom.find('.bonus').text(userdata[totalArray[i]['num']].bonus);
		}
		$userdom.find('.total').text(userdata[totalArray[i]['num']].total);
	};

	if(phase.maxuser == phase.goaluser.length){
		$('#btnContinue').css('display', 'none');
		$('#btnReplay').css('display', 'inline');
	} else {
		$('#btnContinue').css('display', 'inline');
		$('#btnReplay').css('display', 'inline');
	}

}

// フィールド初期化
function fieldInit(){
	phase = new PhaseData();
	var num = sr.usernumber;
	if(num==1){
		userdata[0] = new UserData($('#user1'), '0'+sr.user1);
		$('#user2').remove();
		$('#user3').remove();
		$('#user4').remove();
		phase.user = 0;
		phase.maxuser = 1;
		phase.goalnum = 1;
		phase.soloplay = true;
	} else if(num==2){
		userdata[0] = new UserData($('#user1'), '0'+sr.user1);
		userdata[1] = new UserData($('#user2'), '0'+sr.user2);
		$('#user3').remove();
		$('#user4').remove();
		phase.user = 1;
		phase.maxuser = 2;
		phase.goalnum = 2;
	} else if(num==3){
		userdata[0] = new UserData($('#user1'), '0'+sr.user1);
		userdata[1] = new UserData($('#user2'), '0'+sr.user2);
		userdata[2] = new UserData($('#user3'), '0'+sr.user3);
		$('#user4').remove();
		phase.user = 2;
		phase.maxuser = 3;
		phase.goalnum = 3;
	} else {
		userdata[0] = new UserData($('#user1'), '0'+sr.user1);
		userdata[1] = new UserData($('#user2'), '0'+sr.user2);
		userdata[2] = new UserData($('#user3'), '0'+sr.user3);
		userdata[3] = new UserData($('#user4'), '0'+sr.user4);
		phase.user = 3;
		phase.maxuser = 4;
		phase.goalnum = 4;
	}

	$message = $('#message');
	$cover = $('#notouch');

	$dice = $('#dice');
	$diceBtn = $('#diceBtn img');

	$cardCount = $('#cardCount');
	$infoUser = $('#infoUser img');
	$field = $('#field');

	$q_btnarea = $('#question .btnarea');
	$q_honbun = $('#question .honbun');
	$q_cardimage = $('#question .image img');

	$('#userturn').css('background-image', "url('./shared/images/bar_interface_left_"+num+".png')");
	$('#userturn li:gt('+(Number(num)-1)+')').remove();
	$('#userturn li').on('mouseenter', function(){
		$('#userturn ul').css('background-image',  "url('./shared/images/btn_charatab_"+(Number($(this).index('#userturn li'))+1)+"_over.png')");
	}).on('mouseleave', function(){
		$('#userturn ul').css('background-image',  "url('./shared/images/btn_charatab_"+(Number(phase.viewuser)+1)+"_over.png')");
	}).on('click', function(){
		phase.viewuser = $(this).index('#userturn li');
		changeUserInfo(phase.viewuser);
	});

	minx = 400 - 70;
	maxx = -(1956 - 400);
	miny = 292 - 49;
	maxy = -(1381 - 292);

	moveMap('start', false);
	phaseChange('turnend')

	$('#field').draggable({ cursor: "move",
		drag: function(event , ui) {
			if(flagCover) return false;
			if(ui.position.left > minx || ui.position.left < maxx){
				return false;
			}
			if(ui.position.top > miny || ui.position.top < maxy){
				return false;
			}
		}
	});

	$('#cardBtn').on('click', function(){
		createSubWindow('big', 'card');
	});

	$('#btnContinue').on('click', function(){
		closeSubWindow();
	});

	$('#btnReplay').on('click', function(){
		if(window.confirm('本当に最初から遊びますか？')){
			location.reload();
		}
	});

	$('#question').on('click', '.selectBox li.up' , function(){
		if(selectCount==5){
			selectCount = 0;
		} else {
			selectCount++;
		}
		$(this).parents('.selectBox').find('img').attr('src', './shared/images/select_text_'+selectCount+'.png');
	});

	$('#question').on('click', '.selectBox li.down' , function(){
		if(selectCount==0){
			selectCount = 5;
		} else {
			selectCount--;
		}
		$(this).parents('.selectBox').find('img').attr('src', './shared/images/select_text_'+selectCount+'.png');
	});


	$diceBtn.on('click', function(){
		if(!flagDice){
			changeUserInfo(phase.user);
			flagDice = true;
			$diceBtn.css('display','none');
			timerDiceChange = setInterval( function(){
				var num = Math.floor(Math.random()*6);
				$dice.css('background-position', '0 -' + num + '00px');
			}, 125);
			timerDiceEnd = setTimeout( diceSelected, 800);
		};
	});
}

// プレイヤーセレクト初期化
function playerSelectInit(){
	var preloadFieldImage = new Image();
	preloadFieldImage.src = "./data/images/field.jpg";

	var first = [1,2,3,4,5,6,7,8];
	first = shuffle(first);
	$.each($('#charaSelect .chara'),  function(index, element){
		$(this).find('img').attr('src', './data/images/chara/0'+first[index]+'_select.jpg');
		sr['user'+Number(index+1)] = first[index];
		$(this).find('.up, .down').attr('num', 'user'+(index+1));
	});

	$('#playersNumber .up').on('click',function(){
		var num = sr.usernumber;
		if(num==4){
			num = 1;
		} else {
			num++;
		}

		$('#charaSelect .chara .image').css('opacity', 1);
		if(num==1){
			$('#charaSelect .chara:gt(0) .image').css('opacity',0.2);
		} else if(num==2){
			$('#charaSelect .chara:gt(1) .image').css('opacity',0.2);
		} else if(num==3){
			$('#charaSelect .chara:gt(2) .image').css('opacity',0.2);
		}

		$(this).parents('#playersNumber').find('img').attr('src', './shared/images/number_player_'+num+'p.png');
		sr.usernumber = num;
	});

	$('#playersNumber .down').on('click',function(){
		var num = sr.usernumber;
		if(num==1){
			num = 4;
		} else {
			num--;
		}

		$('#charaSelect .chara .image').css('opacity', 1);
		if(num==1){
			$('#charaSelect .chara:gt(0) .image').css('opacity',0.2);
		} else if(num==2){
			$('#charaSelect .chara:gt(1) .image').css('opacity',0.2);
		} else if(num==3){
			$('#charaSelect .chara:gt(2) .image').css('opacity',0.2);
		}
		$(this).parents('#playersNumber').find('img').attr('src', './shared/images/number_player_'+num+'p.png');
		sr.usernumber = num;
	});

	$('#charaSelect .up').on('click',function(){
		var num = sr[$(this).attr('num')];
		if(num==8){
			num = 1;
		} else {
			num++;
		}
		$(this).parents('.chara').find('img').attr('src', './data/images/chara/0'+num+'_select.jpg');
		sr[$(this).attr('num')] = num;
	});

	$('#charaSelect .down').on('click',function(){
		var num = sr[$(this).attr('num')];
		if(num==1){
			num = 8;
		} else {
			num--;
		}
		$(this).parents('.chara').find('img').attr('src', './data/images/chara/0'+num+'_select.jpg');
		sr[$(this).attr('num')] = num;
	});

	$('#levelSelect .up, #levelSelect .down').on('click',function(){
		if(sr.mode == 'easy'){
			sr.mode = 'medium';
		} else {
			sr.mode = 'easy';
		}
		$(this).parents('#levelSelect').find('img').attr('src', './shared/images/mode_'+sr.mode+'.png');
	});

	$('#levelBtn').on('click',function(){
		$('#settingLevel').css('display','none');
		$('#setting').css('display','block');
	});

	$('#startBtn').on('click',function(){
		var num = sr.usernumber;
		if(num==2){
			if(sr.user1 == sr.user2){
				alert('同一のキャラクターは使用できません。');　return false;
			}
		} else　if(num==3){
			if(sr.user1 == sr.user2){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user2 == sr.user3){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user1 == sr.user3){
				alert('同一のキャラクターは使用できません。');　return false;
			}
		} else {
			if(sr.user1 == sr.user2){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user1 == sr.user3){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user1 == sr.user4){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user2 == sr.user3){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user2 == sr.user4){
				alert('同一のキャラクターは使用できません。');　return false;
			}
			if(sr.user3 == sr.user4){
				alert('同一のキャラクターは使用できません。');　return false;
			}
		}
		fieldInit();
		$('#settingLevel, #setting').css('display','none');
		$('#interface').css('display','block');
	});
}

// 初期関数
$(document).ready(function(){
	addEasing();
	addImageOver('.imgover');
	addMouseover('.imgeffect');

	$('.manualLevel').on('click', function(){
		$('#subwinLevel').stop().css({display:'block', opacity: 0}).animate({opacity:1}, {duration:500, ease:'linear'});
		$('#coverLevel').css('display','block');
	});
	$('#closeLevel').on('click', function(){
		$('#subwinLevel').stop().css({display:'block', opacity: 1}).animate({opacity:0}, {duration:500, ease:'linear',complete: function(){
			$(this).css('display','none');
			$('#coverLevel').css('display','none');
		}});
	});

	$('.manualTop').on('click', function(){
		$('#subwinTop').stop().css({display:'block', opacity: 0}).animate({opacity:1}, {duration:500, ease:'linear'});
		$('#coverTop').css('display','block');
	});
	$('#closeTop').on('click', function(){
		$('#subwinTop').stop().css({display:'block', opacity: 1}).animate({opacity:0}, {duration:500, ease:'linear',complete: function(){
			$(this).css('display','none');
			$('#coverTop').css('display','none');
		}});
	});

	$('.manual').on('click', function(){
		createSubWindow('big', 'manual');
	});
	$('.end').on('click', function(){
		createSubWindow('big', 'ranking');
	});
	$('#close').on('click', function(){
		closeSubWindow();
	});

	playerSelectInit();

	$(window).on('resize', eventResize);
	eventResize();
});

})(jQuery);